<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cybsp__wifi_8c" kind="file" language="C++">
    <compoundname>cybsp_wifi.c</compoundname>
    <includes local="yes">cybsp.h</includes>
    <includes local="yes" refid="cybsp__wifi_8h">cybsp_wifi.h</includes>
    <includes local="yes" refid="cy__network__buffer_8h">cy_network_buffer.h</includes>
    <includes local="yes">cyabs_rtos.h</includes>
    <includes local="yes">whd_types.h</includes>
    <includes local="yes">cyhal.h</includes>
    <includes local="yes">cycfg.h</includes>
    <incdepgraph>
      <node id="18">
        <label>whd_types.h</label>
      </node>
      <node id="19">
        <label>cyhal.h</label>
      </node>
      <node id="15">
        <label>cybsp_wifi.c</label>
        <link refid="cybsp__wifi_8c" />
        <childnode refid="16" relation="include">
        </childnode>
        <childnode refid="17" relation="include">
        </childnode>
        <childnode refid="18" relation="include">
        </childnode>
        <childnode refid="19" relation="include">
        </childnode>
        <childnode refid="20" relation="include">
        </childnode>
      </node>
      <node id="20">
        <label>cycfg.h</label>
      </node>
      <node id="17">
        <label>cyabs_rtos.h</label>
      </node>
      <node id="16">
        <label>cybsp.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="cybsp__wifi_8c_1a90b7a8cb7bc3fdbd98014a3e15ee6e9a" kind="define" prot="public" static="no">
        <name>THREAD_STACK_SIZE</name>
        <initializer>5120</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="37" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="37" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1ad918ca939d6feb90791380688d0cc4fa" kind="define" prot="public" static="no">
        <name>THREAD_PRIORITY</name>
        <initializer>CY_RTOS_PRIORITY_HIGH</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="38" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="38" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1a8a3ec55bd451780d57421ac2b3800a77" kind="define" prot="public" static="no">
        <name>COUNTRY</name>
        <initializer>WHD_COUNTRY_AUSTRALIA</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="39" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="39" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1a2e1427e9a4916a536057f72bcfc04871" kind="define" prot="public" static="no">
        <name>DEFAULT_OOB_PIN</name>
        <initializer>0</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="40" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="40" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1a7eac8359d271ec15c812288bfd4321f5" kind="define" prot="public" static="no">
        <name>WLAN_POWER_UP_DELAY_MS</name>
        <initializer>250</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="41" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="41" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1ab656404c3b5d5f3a32d0898f81013f4a" kind="define" prot="public" static="no">
        <name>SDIO_ENUMERATION_TRIES</name>
        <initializer>500</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="43" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="43" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1ab489185332855ca25780f5975333d7e3" kind="define" prot="public" static="no">
        <name>SDIO_RETRY_DELAY_MS</name>
        <initializer>1</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="44" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="44" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1ae1b81673dc12852be48af513ea0be82e" kind="define" prot="public" static="no">
        <name>SDIO_BUS_LEVEL_MAX_RETRIES</name>
        <initializer>5</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="45" column="9" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="45" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1acca3b2defde1e423420b6fb0c82a6bbb" kind="define" prot="public" static="no">
        <name>CY_WIFI_OOB_INTR_PRIORITY</name>
        <initializer>2</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="48" column="13" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="48" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1ad4ccca671adec4b7452d0fa0f0918324" kind="define" prot="public" static="no">
        <name>CY_SDIO_BUS_USE_OOB_INTR</name>
        <initializer>(1u)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="55" column="13" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="55" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cybsp__wifi_8c_1a80b69276b85d90080f964bd3d3a0ede0" kind="variable" mutable="no" prot="public" static="yes">
        <type>whd_driver_t</type>
        <definition>whd_driver_t whd_drv</definition>
        <argsstring />
        <name>whd_drv</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="84" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="84" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1a3321288215baa5a2026fbff40b674c8b" kind="variable" mutable="no" prot="public" static="no">
        <type>whd_resource_source_t</type>
        <definition>whd_resource_source_t resource_ops</definition>
        <argsstring />
        <name>resource_ops</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="86" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1aefd7af6aacfa86e2e2b6443a9d00e87d" kind="variable" mutable="no" prot="public" static="yes">
        <type>whd_buffer_funcs_t</type>
        <definition>whd_buffer_funcs_t buffer_if_default</definition>
        <argsstring />
        <name>buffer_if_default</name>
        <initializer>=
{
    .whd_host_buffer_get = <ref kindref="member" refid="group__group__bsp__network__buffer_1gacdcb08de31442a9e5d1f32b4e99a2de3">cy_host_buffer_get</ref>,
    .whd_buffer_release = <ref kindref="member" refid="group__group__bsp__network__buffer_1gaac05ad889f09b6e8ef43503ba475a21f">cy_buffer_release</ref>,
    .whd_buffer_get_current_piece_data_pointer = <ref kindref="member" refid="group__group__bsp__network__buffer_1ga782b3a560466f80c438e5c306107eeb1">cy_buffer_get_current_piece_data_pointer</ref>,
    .whd_buffer_get_current_piece_size = <ref kindref="member" refid="group__group__bsp__network__buffer_1ga9890010d1a7246a440477d47dc2c7b2b">cy_buffer_get_current_piece_size</ref>,
    .whd_buffer_set_size = <ref kindref="member" refid="group__group__bsp__network__buffer_1gafd58907304a573df160ea12c97199c2e">cy_buffer_set_size</ref>,
    .whd_buffer_add_remove_at_front = <ref kindref="member" refid="group__group__bsp__network__buffer_1gaa284f33e6c96712370302d61d4b7cd58">cy_buffer_add_remove_at_front</ref>,
}</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="88" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="88" />
      </memberdef>
      <memberdef id="cybsp__wifi_8c_1a86c3e7e24b921d01dfb714ad430a70ca" kind="variable" mutable="no" prot="public" static="yes">
        <type>whd_netif_funcs_t</type>
        <definition>whd_netif_funcs_t netif_if_default</definition>
        <argsstring />
        <name>netif_if_default</name>
        <initializer>=
{
    .whd_network_process_ethernet_data = <ref kindref="member" refid="group__group__bsp__network__buffer_1ga3299898b9eba8861438225b85f36f528">cy_network_process_ethernet_data</ref>,
}</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="98" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="98" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cybsp__wifi_8c_1aa4c52e3a19fcb31aa916aba7eb19d458" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>static cy_rslt_t sdio_try_send_cmd</definition>
        <argsstring>(const cyhal_sdio_t *sdio_object, cyhal_transfer_t direction, cyhal_sdio_command_t command, uint32_t argument, uint32_t *response)</argsstring>
        <name>sdio_try_send_cmd</name>
        <param>
          <type>const cyhal_sdio_t *</type>
          <declname>sdio_object</declname>
        </param>
        <param>
          <type>cyhal_transfer_t</type>
          <declname>direction</declname>
        </param>
        <param>
          <type>cyhal_sdio_command_t</type>
          <declname>command</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>argument</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>response</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="119" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="103" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="103" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cybsp__wifi_8c_1a9509e50edad87c7c116328d5787c39d7" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>static cy_rslt_t cybsp_sdio_enumerate</definition>
        <argsstring>(const cyhal_sdio_t *sdio_object)</argsstring>
        <name>cybsp_sdio_enumerate</name>
        <param>
          <type>const cyhal_sdio_t *</type>
          <declname>sdio_object</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="152" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="121" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="121" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cybsp__wifi_8c_1adce79fb7cb5c9f1bb72c03dfbcaa1f02" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>static cy_rslt_t reset_wifi_chip</definition>
        <argsstring>(void)</argsstring>
        <name>reset_wifi_chip</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="165" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="154" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="154" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cybsp__wifi_8c_1a34070fd7ebd72a4910db516f50d98066" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>static cy_rslt_t init_sdio_bus</definition>
        <argsstring>(void)</argsstring>
        <name>init_sdio_bus</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="208" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="167" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="167" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__wifi_1ga7f491cc7f4a7ecf4b752d0970a1f58f3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cybsp_wifi_init_primary_extended</definition>
        <argsstring>(whd_interface_t *interface, whd_resource_source_t *resource_if, whd_buffer_funcs_t *buffer_if, whd_netif_funcs_t *netif_if)</argsstring>
        <name>cybsp_wifi_init_primary_extended</name>
        <param>
          <type>whd_interface_t *</type>
          <declname>interface</declname>
        </param>
        <param>
          <type>whd_resource_source_t *</type>
          <declname>resource_if</declname>
        </param>
        <param>
          <type>whd_buffer_funcs_t *</type>
          <declname>buffer_if</declname>
        </param>
        <param>
          <type>whd_netif_funcs_t *</type>
          <declname>netif_if</declname>
        </param>
        <briefdescription>
<para>Initializes the primary interface for the WiFi driver on the board. </para>        </briefdescription>
        <detaileddescription>
<para>This sets up the WHD interface to use the <ref kindref="compound" refid="group__group__bsp__network__buffer">Buffer management</ref> APIs and to communicate over the SDIO interface on the board. This function does the following:<linebreak />
 1) Initializes the WiFi driver.<linebreak />
 2) Turns on the WiFi chip.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function cannot be called multiple times. If the interface needs to be reinitialized, &lt;a href="group__group__bsp__wifi.html#group__group__bsp__wifi_1ga77555750b014230bd78143aefb9f379b"&gt;cybsp_wifi_deinit&lt;/a&gt; must be called before calling this function again.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">interface</parametername>
</parameternamelist>
<parameterdescription>
<para>Interface to be initialized </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">resource_if</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to resource interface to provide resources to the driver initialization process. Passing NULL will use the default. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">buffer_if</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a buffer interface to provide buffer related services to the driver instance. Passing NULL will use the default. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">netif_if</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a whd_netif_funcs_t to provide network stack services to the driver instance. Passing NULL will use the default. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS for successful initialization or error if initialization failed. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="236" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="210" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="210" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__wifi_1ga13b5648cec341b96068e2b372388eea4" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cybsp_wifi_init_secondary</definition>
        <argsstring>(whd_interface_t *interface, whd_mac_t *mac_address)</argsstring>
        <name>cybsp_wifi_init_secondary</name>
        <param>
          <type>whd_interface_t *</type>
          <declname>interface</declname>
        </param>
        <param>
          <type>whd_mac_t *</type>
          <declname>mac_address</declname>
        </param>
        <briefdescription>
<para>This function initializes and adds a secondary interface to the WiFi driver. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function does not initialize the WiFi driver or turn on the WiFi chip. That is required to be done by first calling &lt;a href="group__group__bsp__wifi.html#group__group__bsp__wifi_1gafc78b1c0b031052308051088ee2021b7"&gt;cybsp_wifi_init_primary&lt;/a&gt;.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">interface</parametername>
</parameternamelist>
<parameterdescription>
<para>Interface to be initialized </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mac_address</parametername>
</parameternamelist>
<parameterdescription>
<para>Mac address for secondary interface </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS for successful initialization or error if initialization failed. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="241" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="238" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="238" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__wifi_1ga77555750b014230bd78143aefb9f379b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cybsp_wifi_deinit</definition>
        <argsstring>(whd_interface_t interface)</argsstring>
        <name>cybsp_wifi_deinit</name>
        <param>
          <type>whd_interface_t</type>
          <declname>interface</declname>
        </param>
        <briefdescription>
<para>De-initializes all WiFi interfaces and the WiFi driver. </para>        </briefdescription>
        <detaileddescription>
<para>This function does the following:<linebreak />
 1) Deinitializes all WiFi interfaces and WiFi driver.<linebreak />
 2) Turns off the WiFi chip.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">interface</parametername>
</parameternamelist>
<parameterdescription>
<para>Interface to be de-initialized. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS for successful de-initialization or error if de-initialization failed. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="255" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="243" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="243" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__wifi_1ga9f2fb2176d21e958727a75821b346e47" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_driver_t</type>
        <definition>whd_driver_t cybsp_get_wifi_driver</definition>
        <argsstring>(void)</argsstring>
        <name>cybsp_get_wifi_driver</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Gets the wifi driver instance initialized by the driver. </para>        </briefdescription>
        <detaileddescription>
<para>This should only be called after being initialized by <ref kindref="member" refid="group__group__bsp__wifi_1gafc78b1c0b031052308051088ee2021b7">cybsp_wifi_init_primary()</ref> and before being deinitialized by <ref kindref="member" refid="group__group__bsp__wifi_1ga77555750b014230bd78143aefb9f379b">cybsp_wifi_deinit()</ref>. This is also the only time where the driver reference is valid.</para><para><simplesect kind="return"><para>Wifi driver instance pointer. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="260" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" bodystart="257" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" line="257" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides utility functions that are used by board support packages. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="25"><highlight class="preprocessor">#include<sp />"cybsp.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="26"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cybsp_wifi.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_network_buffer.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyabs_rtos.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"whd_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cycfg.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#define<sp />THREAD_STACK_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />5120</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="preprocessor">#define<sp />THREAD_PRIORITY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_RTOS_PRIORITY_HIGH</highlight><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /><highlight class="preprocessor">#define<sp />COUNTRY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />WHD_COUNTRY_AUSTRALIA</highlight><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="preprocessor">#define<sp />DEFAULT_OOB_PIN<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /><highlight class="preprocessor">#define<sp />WLAN_POWER_UP_DELAY_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />250</highlight><highlight class="normal" /></codeline>
<codeline lineno="42"><highlight class="normal" /></codeline>
<codeline lineno="43"><highlight class="normal" /><highlight class="preprocessor">#define<sp />SDIO_ENUMERATION_TRIES<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />500</highlight><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal" /><highlight class="preprocessor">#define<sp />SDIO_RETRY_DELAY_MS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />1</highlight><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /><highlight class="preprocessor">#define<sp />SDIO_BUS_LEVEL_MAX_RETRIES<sp /><sp /><sp /><sp /><sp /><sp />5</highlight><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal" /><highlight class="preprocessor">#if<sp />!defined(CY_WIFI_OOB_INTR_PRIORITY)</highlight><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_OOB_INTR_PRIORITY<sp /><sp /><sp />2</highlight><highlight class="normal" /></codeline>
<codeline lineno="49"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="50"><highlight class="normal" /></codeline>
<codeline lineno="51"><highlight class="normal" /><highlight class="comment">/*<sp />Determine<sp />whether<sp />to<sp />use<sp />the<sp />SDIO<sp />oob<sp />interrupt.</highlight></codeline>
<codeline lineno="52"><highlight class="comment"><sp />*<sp />Use<sp />CY_WIFI_HOST_WAKE_SW_FORCE<sp />to<sp />force<sp />the<sp />enable<sp />status.</highlight></codeline>
<codeline lineno="53"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="54"><highlight class="normal" /><highlight class="preprocessor">#if<sp />!defined(CY_WIFI_HOST_WAKE_SW_FORCE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_SDIO_BUS_USE_OOB_INTR<sp /><sp /><sp /><sp />(1u)</highlight><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_SDIO_BUS_USE_OOB_INTR<sp /><sp /><sp /><sp />CY_WIFI_HOST_WAKE_SW_FORCE</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />defined(CY_WIFI_HOST_WAKE_SW_FORCE)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /></codeline>
<codeline lineno="60"><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CY_SDIO_BUS_USE_OOB_INTR<sp />!=<sp />0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />configuration<sp />based<sp />on<sp />configurator<sp />or<sp />BSP,<sp />where<sp />configurator<sp />has<sp />precedence.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />defined(CYCFG_WIFI_HOST_WAKE_ENABLED)</highlight><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_HOST_WAKE_GPIO<sp /><sp />CYCFG_WIFI_HOST_WAKE_GPIO</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_HOST_WAKE_IRQ_EVENT<sp />CYCFG_WIFI_HOST_WAKE_IRQ_EVENT</highlight><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />host-wake<sp />pin<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />defined(CYBSP_WIFI_HOST_WAKE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_HOST_WAKE_GPIO<sp />CYBSP_WIFI_HOST_WAKE</highlight><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#error<sp />"CYBSP_WIFI_HOST_WAKE<sp />must<sp />be<sp />defined"</highlight><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Setup<sp />host-wake<sp />irq<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />defined(CYBSP_WIFI_HOST_WAKE_IRQ_EVENT)</highlight><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_HOST_WAKE_IRQ_EVENT<sp />CYBSP_WIFI_HOST_WAKE_IRQ_EVENT</highlight><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#error<sp />"CYBSP_WIFI_HOST_WAKE_IRQ_EVENT<sp />must<sp />be<sp />defined"</highlight><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_HOST_WAKE_GPIO<sp /><sp /><sp /><sp /><sp /><sp />CYHAL_NC_PIN_VALUE</highlight><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_WIFI_HOST_WAKE_IRQ_EVENT<sp />0</highlight><highlight class="normal" /></codeline>
<codeline lineno="82"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />(CY_SDIO_BUS_USE_OOB_INTR<sp />!=<sp />0)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal" /></codeline>
<codeline lineno="84"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />whd_driver_t<sp />whd_drv;</highlight></codeline>
<codeline lineno="85"><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp />whd_resource_source_t<sp />resource_ops;</highlight></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />whd_buffer_funcs_t<sp />buffer_if_default<sp />=</highlight></codeline>
<codeline lineno="89"><highlight class="normal">{</highlight></codeline>
<codeline lineno="90"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_host_buffer_get<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gacdcb08de31442a9e5d1f32b4e99a2de3">cy_host_buffer_get</ref>,</highlight></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_buffer_release<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gaac05ad889f09b6e8ef43503ba475a21f">cy_buffer_release</ref>,</highlight></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_buffer_get_current_piece_data_pointer<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1ga782b3a560466f80c438e5c306107eeb1">cy_buffer_get_current_piece_data_pointer</ref>,</highlight></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_buffer_get_current_piece_size<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1ga9890010d1a7246a440477d47dc2c7b2b">cy_buffer_get_current_piece_size</ref>,</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_buffer_set_size<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gafd58907304a573df160ea12c97199c2e">cy_buffer_set_size</ref>,</highlight></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_buffer_add_remove_at_front<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1gaa284f33e6c96712370302d61d4b7cd58">cy_buffer_add_remove_at_front</ref>,</highlight></codeline>
<codeline lineno="96"><highlight class="normal">};</highlight></codeline>
<codeline lineno="97"><highlight class="normal" /></codeline>
<codeline lineno="98"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />whd_netif_funcs_t<sp />netif_if_default<sp />=</highlight></codeline>
<codeline lineno="99"><highlight class="normal">{</highlight></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp />.whd_network_process_ethernet_data<sp />=<sp /><ref kindref="member" refid="group__group__bsp__network__buffer_1ga3299898b9eba8861438225b85f36f528">cy_network_process_ethernet_data</ref>,</highlight></codeline>
<codeline lineno="101"><highlight class="normal">};</highlight></codeline>
<codeline lineno="102"><highlight class="normal" /></codeline>
<codeline lineno="103"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_rslt_t<sp />sdio_try_send_cmd(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cyhal_sdio_t<sp />*sdio_object,<sp />cyhal_transfer_t<sp />direction,<sp />\</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_sdio_command_t<sp />command,<sp />uint32_t<sp />argument,<sp />uint32_t*<sp />response)</highlight></codeline>
<codeline lineno="105"><highlight class="normal">{</highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />loop_count<sp />=<sp />0;</highlight></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp /><ref kindref="member" refid="group__group__bsp__wifi_1gab868840379127847a984d02327620dd4">CYBSP_RSLT_WIFI_SDIO_ENUM_TIMEOUT</ref>;</highlight></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="110"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />cyhal_sdio_send_cmd(sdio_object,<sp />direction,<sp />command,<sp />argument,<sp />response);</highlight></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />!=<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="112"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_system_delay_ms(SDIO_RETRY_DELAY_MS);</highlight></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />loop_count++;</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(result<sp />!=<sp />CY_RSLT_SUCCESS<sp />&amp;&amp;<sp />loop_count<sp />&lt;=<sp />SDIO_BUS_LEVEL_MAX_RETRIES);</highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="119"><highlight class="normal">}</highlight></codeline>
<codeline lineno="120"><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_rslt_t<sp />cybsp_sdio_enumerate(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cyhal_sdio_t<sp />*sdio_object)</highlight></codeline>
<codeline lineno="122"><highlight class="normal">{</highlight></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp /><ref kindref="member" refid="group__group__bsp__wifi_1gab868840379127847a984d02327620dd4">CYBSP_RSLT_WIFI_SDIO_ENUM_TIMEOUT</ref>;</highlight></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />loop_count<sp />=<sp />0;</highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />rel_addr;</highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />response_ignored<sp />=<sp />0;</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />no_argument<sp />=<sp />0;</highlight></codeline>
<codeline lineno="128"><highlight class="normal" /></codeline>
<codeline lineno="129"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />CMD0<sp />to<sp />set<sp />it<sp />to<sp />idle<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />sdio_try_send_cmd(sdio_object,<sp />CYHAL_WRITE,<sp />CYHAL_SDIO_CMD_GO_IDLE_STATE,<sp />no_argument,<sp />&amp;response_ignored<sp /></highlight><highlight class="comment">/*ignored*/</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="133"><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CMD5.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />sdio_try_send_cmd(sdio_object,<sp />CYHAL_READ,<sp />CYHAL_SDIO_CMD_IO_SEND_OP_COND,<sp />no_argument,<sp />&amp;response_ignored<sp /></highlight><highlight class="comment">/*ignored*/</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="136"><highlight class="normal" /></codeline>
<codeline lineno="137"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />CMD3<sp />to<sp />get<sp />RCA.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />sdio_try_send_cmd(sdio_object,<sp />CYHAL_READ,<sp />CYHAL_SDIO_CMD_SEND_RELATIVE_ADDR,<sp />no_argument,<sp />&amp;rel_addr);</highlight></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />!=<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_system_delay_ms(SDIO_RETRY_DELAY_MS);</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />loop_count++;</highlight></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp />}<sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(result<sp />!=<sp />CY_RSLT_SUCCESS<sp />&amp;&amp;<sp />loop_count<sp />&lt;=<sp />SDIO_ENUMERATION_TRIES);</highlight></codeline>
<codeline lineno="145"><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />CMD7<sp />with<sp />the<sp />returned<sp />RCA<sp />to<sp />select<sp />the<sp />card<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />sdio_try_send_cmd(sdio_object,<sp />CYHAL_WRITE,<sp />CYHAL_SDIO_CMD_SELECT_CARD,<sp />rel_addr,<sp />&amp;response_ignored);</highlight></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="152"><highlight class="normal">}</highlight></codeline>
<codeline lineno="153"><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_rslt_t<sp />reset_wifi_chip(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="155"><highlight class="normal">{</highlight></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />WiFi<sp />into<sp />reset<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />cyhal_gpio_init(CYBSP_WIFI_WL_REG_ON,<sp />CYHAL_GPIO_DIR_OUTPUT,<sp />CYHAL_GPIO_DRIVE_PULLUP,<sp />0);</highlight></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />WiFi<sp />out<sp />of<sp />reset<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_write(CYBSP_WIFI_WL_REG_ON,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_system_delay_ms(WLAN_POWER_UP_DELAY_MS);</highlight></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="165"><highlight class="normal">}</highlight></codeline>
<codeline lineno="166"><highlight class="normal" /></codeline>
<codeline lineno="167"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_rslt_t<sp />init_sdio_bus(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="168"><highlight class="normal">{</highlight></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />reset_wifi_chip();</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_sdio_t*<sp />sdio_p<sp />=<sp />cybsp_get_wifi_sdio_obj();</highlight></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />cybsp_sdio_enumerate(sdio_p);</highlight></codeline>
<codeline lineno="174"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_sdio_config_t<sp />whd_sdio_config;</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_oob_config_t<sp />oob_config;</highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_sdio_cfg_t<sp />config;</highlight></codeline>
<codeline lineno="179"><highlight class="normal" /></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />the<sp />configurator<sp />reserved<sp />the<sp />pin,<sp />we<sp />need<sp />to<sp />release<sp />it<sp />here<sp />since</highlight></codeline>
<codeline lineno="181"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />WHD<sp />will<sp />try<sp />to<sp />reserve<sp />it<sp />again.<sp />WHD<sp />has<sp />no<sp />idea<sp />about<sp />configurators</highlight></codeline>
<codeline lineno="182"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />and<sp />expects<sp />it<sp />can<sp />reserve<sp />the<sp />pin<sp />that<sp />it<sp />is<sp />going<sp />to<sp />manage.</highlight></codeline>
<codeline lineno="183"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="184"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />defined(CYCFG_WIFI_HOST_WAKE_ENABLED)</highlight><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_resource_inst_t<sp />pinRsc<sp />=<sp />cyhal_utils_get_gpio_resource(CY_WIFI_HOST_WAKE_GPIO);</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_hwmgr_free(&amp;pinRsc);</highlight></codeline>
<codeline lineno="187"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="188"><highlight class="normal" /></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />oob_config.host_oob_pin<sp />=<sp />CY_WIFI_HOST_WAKE_GPIO;</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />oob_config.dev_gpio_sel<sp />=<sp />DEFAULT_OOB_PIN;</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />oob_config.is_falling_edge<sp />=<sp />(CY_WIFI_HOST_WAKE_IRQ_EVENT<sp />==<sp />CYHAL_GPIO_IRQ_FALL)</highlight></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />WHD_TRUE</highlight></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />WHD_FALSE;</highlight></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />oob_config.intr_priority<sp />=<sp />CY_WIFI_OOB_INTR_PRIORITY;</highlight></codeline>
<codeline lineno="195"><highlight class="normal" /></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_sdio_config.sdio_1bit_mode<sp />=<sp />WHD_FALSE;</highlight></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_sdio_config.high_speed_sdio_clock<sp />=<sp />WHD_FALSE;</highlight></codeline>
<codeline lineno="198"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_sdio_config.oob_config<sp />=<sp />oob_config;</highlight></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_bus_sdio_attach(whd_drv,<sp />&amp;whd_sdio_config,<sp />sdio_p);</highlight></codeline>
<codeline lineno="200"><highlight class="normal" /></codeline>
<codeline lineno="201"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Increase<sp />frequency<sp />to<sp />25<sp />MHz<sp />for<sp />better<sp />performance<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />config.frequencyhal_hz<sp />=<sp />25000000;</highlight></codeline>
<codeline lineno="203"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />config.block_size<sp />=<sp />0;</highlight></codeline>
<codeline lineno="204"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_sdio_configure(sdio_p,<sp />&amp;config);</highlight></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="206"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="207"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="208"><highlight class="normal">}</highlight></codeline>
<codeline lineno="209"><highlight class="normal" /></codeline>
<codeline lineno="210"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__bsp__wifi_1ga7f491cc7f4a7ecf4b752d0970a1f58f3">cybsp_wifi_init_primary_extended</ref>(whd_interface_t*<sp />interface,<sp />whd_resource_source_t<sp />*resource_if,<sp />whd_buffer_funcs_t<sp />*buffer_if,</highlight></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />whd_netif_funcs_t<sp />*netif_if)</highlight></codeline>
<codeline lineno="212"><highlight class="normal">{</highlight></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp />whd_init_config_t<sp />whd_init_config;</highlight></codeline>
<codeline lineno="214"><highlight class="normal"><sp /><sp /><sp /><sp />whd_init_config.thread_stack_size<sp />=<sp />(uint32_t)THREAD_STACK_SIZE;</highlight></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp />whd_init_config.thread_stack_start<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp />whd_init_config.thread_priority<sp />=<sp /><sp />(uint32_t)THREAD_PRIORITY;</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp />whd_init_config.country<sp />=<sp />COUNTRY;</highlight></codeline>
<codeline lineno="218"><highlight class="normal" /></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(resource_if<sp />==<sp />NULL)</highlight></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />resource_if<sp />=<sp />&amp;resource_ops;</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(buffer_if<sp />==<sp />NULL)</highlight></codeline>
<codeline lineno="222"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />buffer_if<sp />=<sp />&amp;buffer_if_default;</highlight></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(netif_if<sp />==<sp />NULL)</highlight></codeline>
<codeline lineno="224"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />netif_if<sp />=<sp />&amp;netif_if_default;</highlight></codeline>
<codeline lineno="225"><highlight class="normal" /></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />whd_init(&amp;whd_drv,<sp />&amp;whd_init_config,<sp />resource_if,<sp />buffer_if,<sp />netif_if);</highlight></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="228"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />init_sdio_bus();</highlight></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />whd_wifi_on(whd_drv,<sp />interface);</highlight></codeline>
<codeline lineno="233"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="234"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="236"><highlight class="normal">}</highlight></codeline>
<codeline lineno="237"><highlight class="normal" /></codeline>
<codeline lineno="238"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__bsp__wifi_1ga13b5648cec341b96068e2b372388eea4">cybsp_wifi_init_secondary</ref>(whd_interface_t*<sp />interface,<sp />whd_mac_t*<sp />mac_address)</highlight></codeline>
<codeline lineno="239"><highlight class="normal">{</highlight></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />whd_add_secondary_interface(whd_drv,<sp />mac_address,<sp />interface);</highlight></codeline>
<codeline lineno="241"><highlight class="normal">}</highlight></codeline>
<codeline lineno="242"><highlight class="normal" /></codeline>
<codeline lineno="243"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__bsp__wifi_1ga77555750b014230bd78143aefb9f379b">cybsp_wifi_deinit</ref>(whd_interface_t<sp />interface)</highlight></codeline>
<codeline lineno="244"><highlight class="normal">{</highlight></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result<sp />=<sp />whd_wifi_off(interface);</highlight></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />whd_deinit(interface);</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline lineno="250"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cyhal_gpio_free(CYBSP_WIFI_WL_REG_ON);</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="255"><highlight class="normal">}</highlight></codeline>
<codeline lineno="256"><highlight class="normal" /></codeline>
<codeline lineno="257"><highlight class="normal">whd_driver_t<sp /><ref kindref="member" refid="group__group__bsp__wifi_1ga9f2fb2176d21e958727a75821b346e47">cybsp_get_wifi_driver</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="258"><highlight class="normal">{</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />whd_drv;</highlight></codeline>
<codeline lineno="260"><highlight class="normal">}</highlight></codeline>
<codeline lineno="261"><highlight class="normal" /></codeline>
<codeline lineno="262"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="263"><highlight class="normal">}</highlight></codeline>
<codeline lineno="264"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cybsp_wifi.c" />
  </compounddef>
</doxygen>